% Subroutine for computing "alpha" by solving a linear system
% Coded by Jianhui Chen (jianhui.chen@asu.edu, Arizona State University)

function [ alpha val ] = compute_alpha_ls(G, theta,lambda, H)

len = length(G);
[ n num_c ] = size( H );

G_Sum = zeros( n, n );
for i = 1 : len
    G_Sum = G_Sum + theta(i) * G{i};
end

G_Sum =  1 / (2 * lambda) * G_Sum + 1 / 2 * diag( ones(n,1) ) ; 
%G_Sum_inv = pinv(G_Sum);

alpha = G_Sum\H;

val = 0;
for cc = 1:num_c
%    alpha(:,cc) = G_Sum_inv *  H(:,cc);
    val  = val - 1 / 2 * alpha(:,cc)' * H(:,cc);
end
